﻿using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.DotProlog.Execution;
using OpcLabs.DotProlog.Terms;
using OpcLabs.DotProlog.Test;

namespace DotPrologTest.Execution
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class Disjunction_2_Test : ExecutionTest
    {
        #region Test Methods
        // ReSharper disable InconsistentNaming

        [TestMethod]
        public void Test1()
        {
            using (IEngine engine = new Engine())
            {
                Term goal = Parse("';'(X=1, X=2). ", out IDictionary<string, Variable> variableNameDictionary);
                var expected1 = new VariableDictionary { { variableNameDictionary["X"], new PInteger(1) } };
                var expected2 = new VariableDictionary { { variableNameDictionary["X"], new PInteger(2) } };
                Test(engine, goal, Success(expected1, expected2));
                // TODO: FrontEnd.PrintResults(engine.Call(goal), variableNameDictionary);
            }
        }

        [TestMethod]
        public void Test_7_8_6_4_Examples_1()
        {
            using (IEngine engine = new Engine())
            {
                Test(engine, Parse("';'(true, false). "), Success(), "Expected success.");
            }
        }

        [TestMethod]
        public void Test_7_8_6_4_Examples_2()
        {
            using (IEngine engine = new Engine())
            {
                Test(engine, Parse("';'((!, fail), true). "), Failure(), "Expected failure.");
            }
        }

        [TestMethod]
        public void Test_7_8_6_4_Examples_3()
        {
            using (IEngine engine = new Engine())
            {
                Test(engine, Parse("';'(!, call(3)). "), Success(), "Expected success.");
            }
        }

        [TestMethod]
        public void Test_7_8_6_4_Examples_4()
        {
            using (IEngine engine = new Engine())
            {
                Term goal = Parse("';'((X = 1, !), X = 2). ", out IDictionary<string, Variable> variableNameDictionary);
                Term expectedX = new PInteger(1);
                var expected = new VariableDictionary { { variableNameDictionary["X"], expectedX } };
                Test(engine, goal, Success(expected));
                //FrontEnd.PrintResults(engine.Call(goal), variableNameDictionary);
            }
        }

        [TestMethod]
        public void Test_7_8_6_4_Examples_5()
        {
            using (IEngine engine = new Engine())
            {
                Term goal = Parse("','(';'(X=1, X=2), ';'(true, !)). ", out IDictionary<string, Variable> variableNameDictionary);
                var expected1 = new VariableDictionary { { variableNameDictionary["X"], new PInteger(1) } };
                var expected2 = new VariableDictionary { { variableNameDictionary["X"], new PInteger(1) } };
                Test(engine, goal, Success(expected1, expected2));
                //FrontEnd.PrintResults(engine.Call(goal), variableNameDictionary);
            }
        }

        // ReSharper restore InconsistentNaming
        #endregion
    }
}
