﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.IO;
using OpcLabs.BaseLib.OperationModel;
using OpcLabs.BaseLib.OperationModel.Generic;
using OpcLabs.BaseLib.Utilities;
using OpcLabs.DotProlog.Code;
using OpcLabs.DotProlog.Execution;
using OpcLabs.DotProlog.Execution.Extensions;
using OpcLabs.DotProlog.InputOutput;
using OpcLabs.DotProlog.Loading;
using OpcLabs.DotProlog.Terms;

namespace DotPrologTest.Libraries.System.Reflection
{
    [TestClass]
    public class MemberInfoTest
    {
        [TestMethod]
        public void Test1()
        {
            var loader = new Loader();
            var streamLoader = new StreamLoader<IDatabase>(stream =>
            {
                // ReSharper disable once AssignNullToNotNullAttribute
                TextStream textStream = TextStream.Create(InputOutputMode.Read, stream);
                loader.Consult(textStream);// TODO: how are errors reported?
                return ValueResult.Success(loader.Database);
            });

            ValueResult<IDatabase> valueResult;
            valueResult = streamLoader.FromManagedResource(UriUtilities.MakeNetResourceUri(
                typeof(Term).Assembly.FullName,
                "OpcLabs.DotProlog.Libraries.clr.pl"));
            Assert.IsTrue(valueResult.Succeeded);
            valueResult = streamLoader.FromManagedResource(UriUtilities.MakeNetResourceUri(
                typeof(Term).Assembly.FullName,
                "OpcLabs.DotProlog.Libraries.lists.pl"));
            Assert.IsTrue(valueResult.Succeeded);
            valueResult = streamLoader.FromManagedResource(UriUtilities.MakeNetResourceUri(
                typeof(Term).Assembly.FullName,
                "OpcLabs.DotProlog.Libraries.System.Array.pl"));
            Assert.IsTrue(valueResult.Succeeded);
            valueResult = streamLoader.FromManagedResource(UriUtilities.MakeNetResourceUri(
                typeof(Term).Assembly.FullName,
                "OpcLabs.DotProlog.Libraries.System.Reflection.MemberInfo.pl"));
            Assert.IsTrue(valueResult.Succeeded);

            IDatabase database = loader.Database;

            var result = new Variable();
            Term goal = new NTerm("System.Reflection.MemberInfo.GetCustomAttributes")
            {
                new ClrObject(typeof(MemberInfoTest)),
                Atom.Add("true"),
                result
            };
            using (IEngine engine = new Engine(new Program(new OpcLabs.DotProlog.Code.Module(database))))
            {
                IEnumerable<Solution> results = engine.Call(goal);

                var x = results.First();
                // TODO: check the solution
            }
        }
    }
}
