﻿using System;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Runtime.InteropServices;
using OpcLabs.BaseLib.Runtime.InteropServices.Internal;

namespace OpcLabs.BaseLibTest.Runtime.InteropServices
{
    public partial class OADateRoundtripTest
    {
        [TestMethod]
        public void BasicTest()
        {
            var target = new OADateRoundtrip();

            DateTime originalDateTime = new DateTime(2020, 1, 31, 20, 26, 0);
            double oaDate = target.FromDateTime(originalDateTime);
            DateTime roundtrippedDateTime = target.ToDateTime(oaDate);
            Assert.AreEqual(originalDateTime, roundtrippedDateTime);
            Assert.AreEqual(0, target.AmbiguousConversionCount);
            Assert.AreEqual(0, target.CollectionCount);
        }

        [TestMethod]
        public void CollectionTest()
        {
            var target = new OADateRoundtrip {CollectionThreshold = 10, CollectionNewSize = 2};

            DateTime originalDateTime = new DateTime(2020, 1, 31, 20, 26, 0);
            for (int i = 0; i < 20; i++)
            {
                double oaDate = target.FromDateTime(originalDateTime);
                originalDateTime = originalDateTime.AddSeconds(1);
            }
            Assert.AreEqual(0, target.AmbiguousConversionCount);
            Assert.AreEqual(2, target.CollectionCount);
        }
    }
}
