﻿using System;
using JetBrains.Annotations;
using OpcLabs.EasyOpc;

namespace OpcLabs.EasyOpcLiveTest.DataAccess
{
    static class SimulatedDAServerCatalogEntry
    {
        [NotNull]
        static public DAServerCatalogEntry Create([NotNull] string location)
        {
            // ReSharper disable RedundantArgumentName

            var catalogEntry = new DAServerCatalogEntry(new ServerElement(
                location:location, 
                clsid:Guid.Parse("{57ED2C7E-3474-47E7-B1FE-4D8C5E942613}"),
                progId: "Acme.SimulatedDAServer1", 
                versionIndependentProgId:"",
                description: "Simulated OPC-DA Server 1",
                vendor:"Acme",
                serverCategories:new ServerCategories {OpcDataAccess10 = true, OpcDataAccess20 = true, OpcDataAccess30 = true},
                scheme:ServerDescriptor.OpcDAScheme));

            // TODO: items, ...

            return catalogEntry;
            // ReSharper restore RedundantArgumentName
        }
    }
}
