﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.DataAccess.OperationModel;
using OpcLabs.EasyOpcLiveTest.Legacy.Environment.OpcKitServer;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcLiveTest.Legacy.DataAccess.OperationModel
{
    public class DAVtqResultTest
    {

        [TestCategory("BinarySerialization")]
        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestMethod]
        public void BinarySerializationTestLive()
        {
            Tests.BinarySerializationTest(CreateSerializationTargetLive());
        }

        [TestCategory("Live")]
        [TestCategory("OpcClassic")]
        [TestCategory("OpcDataAccess")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTestLive()
        {
            Tests.XmlSerializationTest(CreateSerializationTargetLive());
        }

        [NotNull]
        private DAVtqResult CreateSerializationTargetLive()
        {
            DAVtqResult[] vtqResults = EasyDAClient.SharedInstance.ReadMultipleItems(new[] { new DAReadItemArguments("", KitServer.ProgId, "Simulation.Random", 1000) });
            Assert.IsNotNull(vtqResults);
            DAVtqResult vtqResult = vtqResults[0];
            Assert.IsNotNull(vtqResult);
            return vtqResult;
        }
    }
}
