﻿using System;
using System.Diagnostics.CodeAnalysis;
using JetBrains.Annotations;
using OpcLabs.BaseLib.Diagnostics;
using OpcLabs.EasyOpc.UA.LiveMapping;

namespace OpcLabs.EasyOpcLiveTest.UA.Environment.UASampleServer
{
    [CLSCompliant(false)]
    [UANamespace("http://test.org/UA/Data/")]
#pragma warning disable 3021
    public class ObjectsNode : UAMappedNode
#pragma warning restore 3021
    {
        [SuppressMessage("Microsoft.Usage", "CA2214:DoNotCallOverridableMethodsInConstructors")]    // caused by Code Contracts
        public ObjectsNode()
        {
            Data = new DataNode();
        }

        [NotNull]
        [UANode]
        public DataNode Data { get; set; }  // non-nullness by invariant

        [UsedImplicitly]
        private void ObjectInvariant()
        {
            // Auto-implemented properties
            Check.Invariant(Data != null);
        }
    }
}
