﻿using System.Diagnostics;
using System.IO;
using System.Reflection;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Collections.Specialized;
using OpcLabs.BaseLib.OperationModel.Generic;
using OpcLabs.EasyOpc.UA.PubSub.Configuration;
using OpcLabs.EasyOpc.UA.PubSub.Configuration.Extensions;
using OpcLabs.EasyOpc.UA.PubSub.Configuration.Implementation;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.PubSub.InformationModel
{
    [TestClass]
    public class UAPubSubMemoryConfigurationTest
    {
        [TestMethod]
        public void LoadFromUABinaryStreamTest()
        {
            TestSection.Arrange();
            Stream stream = Assembly.GetExecutingAssembly().GetManifestResourceStream(
                "OpcLabs.EasyOpcTest.UA.PubSub.InformationModel.pubsubconfig.bin");
            Debug.Assert(stream != null);

            TestSection.Act();
            ValueResult<IUAPubSubConfiguration> pubSubMemoryConfigurationResult = 
                UAPubSubMemoryConfiguration.UABinaryLoader.FromStream(stream);

            TestSection.Assert();
            Assert.IsTrue(pubSubMemoryConfigurationResult.Succeeded);
            IUAReadOnlyPubSubConfiguration pubSubMemoryConfiguration = pubSubMemoryConfigurationResult.Value;
            Assert.IsNotNull(pubSubMemoryConfiguration);
            StringCollection allPublishedDataSetNames = pubSubMemoryConfiguration.ListAllPublishedDataSetNames();
            Assert.IsNotNull(allPublishedDataSetNames);
            Assert.AreEqual(3, allPublishedDataSetNames.Count);
            StringCollection dataSetFolderNames = pubSubMemoryConfiguration.ListDataSetFolderNames(new string[0]);
            Assert.IsNotNull(dataSetFolderNames);
            Assert.AreEqual(0, dataSetFolderNames.Count);
            StringCollection pubSubConnectionNames = pubSubMemoryConfiguration.ListConnectionNames();
            Assert.IsNotNull(pubSubConnectionNames);
            Assert.AreEqual(1, pubSubConnectionNames.Count);
            // IMPROVE: assert more
        }
    }
}
