﻿using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;
using OpcLabs.EasyOpc.UA.AddressSpace.Standard;
using OpcLabs.EasyOpc.UA.OperationModel;
using OpcLabs.EasyOpc.UA.Reactive;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.UA.Reactive
{
    [TestClass]
    public class UADataChangeNotificationObservableTest
    {
        #region Test Methods

        [TestCategory("OpcUA")]
        [TestMethod]
        public void CreateTest()
        {
            TestSection.Arrange();

            UAEndpointDescriptor endpointDescriptor = new UAEndpointDescriptor("testDescriptorString");
            UANodeDescriptor nodeDescriptor = new UANodeDescriptor(UAObjectIds.ObjectsFolder);

            TestSection.Act();

            UADataChangeNotificationObservable<int> target = UADataChangeNotificationObservable.Create<int>(
                endpointDescriptor,
                nodeDescriptor,
                99);

            TestSection.Assert();

            Assert.IsNotNull(target.ClientSelector);
            Assert.AreSame(UAReactive.DefaultClientSelector, target.ClientSelector);
            Assert.IsNotNull(target.Arguments);
            UAMonitoredItemArguments[] argumentsArray = target.Arguments.ToArray();
            Assert.AreEqual(1, argumentsArray.Length);
            UAMonitoredItemArguments arguments = argumentsArray[0];
            Assert.IsNotNull(arguments);
            Assert.AreEqual("opc.tcp:testDescriptorString", arguments.EndpointDescriptor.UrlString);
            Assert.AreEqual(UAObjectIds.ObjectsFolder, arguments.NodeDescriptor.NodeId);
            Assert.AreEqual(0, arguments.IndexRangeList.Count);
            Assert.AreEqual(UAAttributeId.Value, arguments.AttributeId);
            Assert.IsNull(arguments.State);
        }

        #endregion
    }
}
