﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class YokogawaElectricCorporation_MdisDemoServer_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "ns=5;i=10558",
            "ns=5;i=10653"
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://10.10.102.194:62540/MDISServer" };

        public override string Password => "demo";

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),
            nameof(Group001_Session_Test08_CreateSession_InstanceCertificate),
            nameof(Group001_Session_Test09_CreateSession_Https_None),
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),
            nameof(Group002_ViewServices_Test01_Browse_SingleNode),
            nameof(Group002_ViewServices_Test02_Browse_Walk),
            nameof(Group002_ViewServices_Test03_Browse_References),
            nameof(Group002_ViewServices_Test04_Browse_NodeClasses),
            nameof(Group002_ViewServices_Test07_TranslateBrowsePathToNodeId_Components),
            nameof(Group003_AttributeServices_Test05_Read_Array_IndexRange),
            nameof(Group003_AttributeServices_Test07_Write_Array_IndexRange),
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence),
            nameof(Group014_Challenge_Test02_ShortNetworkInterruption),
            nameof(Group014_Challenge_Test03_LongNetworkInterruption),

            nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            nameof(Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256),
            nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256),
            nameof(Group102_Session2_Test04_CreateSession_UaTcp_Aes128_Sha256_RsaOaep),
            nameof(Group102_Session2_Test05_CreateSession_UaTcp_Aes256_Sha256_RsaPss),
            nameof(Group114_Challenge2_Test01_LongRunningSubscription),
        });

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "ns=6;i=2720" };

        public override string UserName => "sysadmin";
    }
}
